Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 1 | # SPDX-License-Identifier: GPL-2.0 |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 2 | ifdef CONFIG_GCC_PLUGINS |
| 3 | __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC)) |
| 4 | PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)") |
| 5 | |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 6 | SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so |
| 7 | |
Emese Revfy | 0dae776 | 2016-05-24 00:10:35 +0200 | [diff] [blame] | 8 | gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 9 | |
Emese Revfy | 38addce | 2016-06-20 20:41:19 +0200 | [diff] [blame] | 10 | gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so |
| 11 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN |
Andrew Donnellan | 7b4010e | 2016-12-06 17:27:58 +1100 | [diff] [blame] | 12 | ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY |
Emese Revfy | 38addce | 2016-06-20 20:41:19 +0200 | [diff] [blame] | 13 | DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable |
| 14 | endif |
| 15 | |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 16 | ifdef CONFIG_GCC_PLUGIN_SANCOV |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 17 | # It is needed because of the gcc-plugin.sh and gcc version checks. |
| 18 | gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so |
| 19 | |
Masahiro Yamada | 5aadfde | 2018-05-28 18:22:04 +0900 | [diff] [blame] | 20 | ifeq ($(PLUGINCC),) |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 21 | $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler) |
| 22 | endif |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 23 | endif |
| 24 | |
Kees Cook | c61f13e | 2017-01-13 11:14:39 -0800 | [diff] [blame] | 25 | gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so |
| 26 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose |
Ard Biesheuvel | f7dd250 | 2017-08-06 12:06:27 +0100 | [diff] [blame] | 27 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL) += -fplugin-arg-structleak_plugin-byref-all |
Kees Cook | c61f13e | 2017-01-13 11:14:39 -0800 | [diff] [blame] | 28 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN |
| 29 | |
Kees Cook | 313dd1b6 | 2017-05-05 23:37:45 -0700 | [diff] [blame] | 30 | gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so |
| 31 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN |
| 32 | gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode |
| 33 | |
Emese Revfy | 65d59ec | 2016-06-20 20:40:24 +0200 | [diff] [blame] | 34 | GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y)) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 35 | |
Emese Revfy | 38addce | 2016-06-20 20:41:19 +0200 | [diff] [blame] | 36 | export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR |
Masahiro Yamada | 5aadfde | 2018-05-28 18:22:04 +0900 | [diff] [blame] | 37 | export DISABLE_LATENT_ENTROPY_PLUGIN |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 38 | |
Kees Cook | ed58c0e | 2016-06-17 23:11:12 -0700 | [diff] [blame] | 39 | ifneq ($(PLUGINCC),) |
Emese Revfy | 543c37c | 2016-05-24 00:11:37 +0200 | [diff] [blame] | 40 | # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication. |
| 41 | GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS)) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 42 | endif |
| 43 | |
| 44 | KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS) |
| 45 | GCC_PLUGIN := $(gcc-plugin-y) |
Emese Revfy | caefd8c | 2016-06-26 17:38:20 +0200 | [diff] [blame] | 46 | GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y) |
Emese Revfy | 6b90bd4 | 2016-05-24 00:09:38 +0200 | [diff] [blame] | 47 | endif |
Kees Cook | ed58c0e | 2016-06-17 23:11:12 -0700 | [diff] [blame] | 48 | |
| 49 | # If plugins aren't supported, abort the build before hard-to-read compiler |
| 50 | # errors start getting spewed by the main build. |
| 51 | PHONY += gcc-plugins-check |
| 52 | gcc-plugins-check: FORCE |
| 53 | ifdef CONFIG_GCC_PLUGINS |
| 54 | ifeq ($(PLUGINCC),) |
| 55 | ifneq ($(GCC_PLUGINS_CFLAGS),) |
| 56 | ifeq ($(call cc-ifversion, -ge, 0405, y), y) |
| 57 | $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true |
| 58 | @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1 |
| 59 | else |
| 60 | @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1 |
| 61 | endif |
| 62 | endif |
| 63 | endif |
| 64 | endif |
| 65 | @: |
| 66 | |
| 67 | # Actually do the build, if requested. |
| 68 | PHONY += gcc-plugins |
| 69 | gcc-plugins: scripts_basic gcc-plugins-check |
| 70 | ifdef CONFIG_GCC_PLUGINS |
| 71 | $(Q)$(MAKE) $(build)=scripts/gcc-plugins |
| 72 | endif |
| 73 | @: |